﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Diagnostics;
using System.Data.OleDb;
using System.Text;

namespace AspNetWebboardCS
{
    public partial class ViewWebboard : System.Web.UI.Page
    {
        protected OleDbConnection objConn;
        protected string strQuestionID = HttpContext.Current.Request.QueryString["QuestionID"];

        protected int strReplyNo = 1;

        protected void Page_Load(object sender, EventArgs e)
        {

            string strConnString = null;
            strConnString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=|DataDirectory|\\database.mdb";
            objConn = new OleDbConnection(strConnString);
            objConn.Open();

            ShowQuestion();
            ShowReply();

        }

        protected void ShowQuestion()
        {
            OleDbDataAdapter dtAdapter = null;
            OleDbCommand objCmd = null;
            DataTable dt = new DataTable();
            StringBuilder strSQL = new StringBuilder();
            strSQL.Append("SELECT * FROM webboard ");
            strSQL.Append(" WHERE QuestionID = " + strQuestionID + " ");
            dtAdapter = new OleDbDataAdapter(strSQL.ToString(), objConn);
            dtAdapter.Fill(dt);

            if (dt.Rows.Count > 0)
            {
                this.lblQuestion.Text = dt.Rows[0]["Question"].ToString();
                this.lblDetails.Text = dt.Rows[0]["Details"].ToString();
                this.lblName.Text = "<b>Name : </b>" + dt.Rows[0]["Name"].ToString();
                this.lblCreateDate.Text = "<b>CreateDate : </b>" + Convert.ToDateTime(dt.Rows[0]["CreateDate"]).ToString("dd/MM/yyyy HH:mm").ToString();
                this.lblReply.Text = "<b>Reply : </b>" + dt.Rows[0]["Reply"].ToString();
                this.lblView.Text = "<b>View : </b>" + dt.Rows[0]["View"].ToString();
            }

            //*** Update Number of View ***'
            strSQL.Remove(0, strSQL.Length);
            strSQL.Append(" UPDATE webboard SET [View] = [View] + 1 ");
            strSQL.Append(" WHERE QuestionID = @sQuestionID ");
            objCmd = new OleDbCommand(strSQL.ToString(), objConn);
            objCmd.Parameters.Add("@sQuestionID", OleDbType.VarChar).Value = strQuestionID.ToString();
            objCmd.ExecuteNonQuery();

        }


        protected void ShowReply()
        {
            StringBuilder strSQL = new StringBuilder();
            OleDbCommand objCmd = null;

            strSQL.Append(" SELECT * FROM reply ");
            strSQL.Append(" WHERE QuestionID = " + strQuestionID + " ");

            OleDbDataReader dtReader = null;
            objCmd = new OleDbCommand(strSQL.ToString(), objConn);
            dtReader = objCmd.ExecuteReader();

            //*** BindData to Repeater ***'
            myRepeater.DataSource = dtReader;
            myRepeater.DataBind();

            dtReader.Close();
            dtReader = null;

        }

        protected void Page_UnLoad(object sender, EventArgs e)
        {
            objConn.Close();
            objConn = null;
        }

        protected void btnSave_Click(object sender, EventArgs e)
        {

            StringBuilder strSQL = new StringBuilder();
            OleDbCommand objCmd = null;

            //*** Insert Reply ***'
            strSQL.Append(" INSERT INTO reply (QuestionID,CreateDate,Details,Name) ");
            strSQL.Append(" VALUES ");
            strSQL.Append(" (@sQuestionID,@sCreateDate,@sDetails,@sName) ");
            objCmd = new OleDbCommand(strSQL.ToString(), objConn);
            objCmd.Parameters.Add("@sQuestionID", OleDbType.VarChar).Value = strQuestionID.ToString();
            objCmd.Parameters.Add("@sCreateDate", OleDbType.Date).Value = DateTime.Now.ToString();
            objCmd.Parameters.Add("@sDetails", OleDbType.VarChar).Value = this.txtDetails.Text;
            objCmd.Parameters.Add("@sName", OleDbType.VarChar).Value = this.txtName.Text;
            objCmd.ExecuteNonQuery();

            //*** Update Number of Reply ***'
            strSQL.Remove(0, strSQL.Length);
            strSQL.Append(" UPDATE webboard SET Reply = Reply + 1 ");
            strSQL.Append(" WHERE QuestionID = @sQuestionID ");
            objCmd = new OleDbCommand(strSQL.ToString(), objConn);
            objCmd.Parameters.Add("@sQuestionID", OleDbType.VarChar).Value = strQuestionID.ToString();
            objCmd.ExecuteNonQuery();

            Response.Redirect("ViewWebboard.aspx?QuestionID=" + strQuestionID);

        }

        protected void myRepeater_ItemDataBound(object sender, RepeaterItemEventArgs e)
        {
            if (e.Item.ItemType == ListItemType.Item | e.Item.ItemType == ListItemType.AlternatingItem)
            {
                //*** No ***'
                Label lblReplyNo = (Label)e.Item.FindControl("lblReplyNo");
                if ((lblReplyNo != null))
                {
                    lblReplyNo.Text = "No : " + strReplyNo;
                    strReplyNo = strReplyNo + 1;
                }

                //*** Details ***'
                Label lblReplyDetails = (Label)e.Item.FindControl("lblReplyDetails");
                if ((lblReplyDetails != null))
                {
                    lblReplyDetails.Text = (string)DataBinder.Eval(e.Item.DataItem, "Details");
                }

                //*** Name ***'
                Label lblReplyName = (Label)e.Item.FindControl("lblReplyName");
                if ((lblReplyName != null))
                {
                    lblReplyName.Text = (string)DataBinder.Eval(e.Item.DataItem, "Name");
                }

                //*** CreateDate ***'
                Label lblReplyCreateDate = (Label)e.Item.FindControl("lblReplyCreateDate");
                if ((lblReplyCreateDate != null))
                {
                    lblReplyCreateDate.Text = Convert.ToDateTime(DataBinder.Eval(e.Item.DataItem, "CreateDate")).ToString("dd/MM/yyyy HH:mm");
                }

            }

        }




    }
}
