﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Diagnostics;
using System.Data.OleDb;
using System.Text;

namespace AspNetWebboardCS
{

    public partial class Webboard : System.Web.UI.Page
    {
        protected OleDbConnection objConn;

        protected void Page_Load(object sender, EventArgs e)
        {

            string strConnString = null;
            strConnString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=|DataDirectory|\\database.mdb";
            objConn = new OleDbConnection(strConnString);
            objConn.Open();

            if (!Page.IsPostBack)
            {
                ShowWebboard();
            }

        }

        protected void ShowWebboard()
        {
            OleDbDataAdapter dtAdapter = new OleDbDataAdapter();
            OleDbCommand objCmd = new OleDbCommand();
            DataSet ds = new DataSet();

            StringBuilder strSQL = new StringBuilder();
            strSQL.Append(" SELECT * FROM webboard ");
            strSQL.Append(" ORDER BY QuestionID DESC ");

            var _with1 = objCmd;
            _with1.Connection = objConn;
            _with1.CommandText = strSQL.ToString();
            _with1.CommandType = CommandType.Text;
            dtAdapter.SelectCommand = objCmd;

            dtAdapter.Fill(ds);

            myGridView.AllowPaging = true;
            myGridView.PageSize = 5;
            myGridView.DataSource = ds.Tables[0];
            myGridView.DataBind();

        }

        protected void myGridView_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            myGridView.PageIndex = e.NewPageIndex;
            ShowWebboard();
        }

        protected void myGridView_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                //*** QuestionID ***'
                Label lblQuestionID = (Label)e.Row.FindControl("lblQuestionID");
                if ((lblQuestionID != null))
                {
                    lblQuestionID.Text = DataBinder.Eval(e.Row.DataItem, "QuestionID").ToString();
                }

                //*** CreateDate ***'
                Label lblCreateDate = (Label)e.Row.FindControl("lblCreateDate");
                if ((lblCreateDate != null))
                {
                    lblCreateDate.Text = Convert.ToDateTime(DataBinder.Eval(e.Row.DataItem, "CreateDate")).ToString("dd/MM/yyyy HH:mm");
                }

                //*** Question ***'
                HyperLink hplQuestion = (HyperLink)e.Row.FindControl("hplQuestion");
                if ((hplQuestion != null))
                {
                    hplQuestion.Text = (string)DataBinder.Eval(e.Row.DataItem, "Question");
                    hplQuestion.NavigateUrl = "ViewWebboard.aspx?QuestionID=" + DataBinder.Eval(e.Row.DataItem, "QuestionID").ToString();
                }

                //*** Name ***'
                Label lblName = (Label)e.Row.FindControl("lblName");
                if ((lblName != null))
                {
                    lblName.Text = (string)DataBinder.Eval(e.Row.DataItem, "Name");
                }

                //*** View ***'
                Label lblView = (Label)e.Row.FindControl("lblView");
                if ((lblView != null))
                {
                    lblView.Text = DataBinder.Eval(e.Row.DataItem, "View").ToString(); ;
                }

                //*** Reply ***'
                Label lblReply = (Label)e.Row.FindControl("lblReply");
                if ((lblReply != null))
                {
                    lblReply.Text = DataBinder.Eval(e.Row.DataItem, "Reply").ToString(); ;
                }

            }

        }

        protected void Page_UnLoad(object sender, EventArgs e)
        {
            objConn.Close();
            objConn = null;
        }

    }
}
