﻿Imports System.Data
Imports System.Data.OleDb

Partial Public Class Webboard
    Inherits System.Web.UI.Page

    Protected objConn As OleDbConnection

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Dim strConnString As String
        strConnString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=|DataDirectory|\database.mdb"
        objConn = New OleDbConnection(strConnString)
        objConn.Open()

        If Not Page.IsPostBack() Then
            ShowWebboard()
        End If

    End Sub

    Protected Sub ShowWebboard()

        Dim dtAdapter As New OleDbDataAdapter
        Dim objCmd As New OleDbCommand
        Dim ds As New DataSet

        Dim strSQL As New StringBuilder
        strSQL.Append(" SELECT * FROM webboard ")
        strSQL.Append(" ORDER BY QuestionID DESC ")

        With objCmd
            .Connection = objConn
            .CommandText = strSQL.ToString
            .CommandType = CommandType.Text
        End With
        dtAdapter.SelectCommand = objCmd

        dtAdapter.Fill(ds)

        myGridView.AllowPaging = True
        myGridView.PageSize = 5
        myGridView.DataSource = ds.Tables(0)
        myGridView.DataBind()

    End Sub

    Protected Sub myGridView_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles myGridView.PageIndexChanging

        myGridView.PageIndex = e.NewPageIndex
        ShowWebboard()

    End Sub

    Protected Sub myGridView_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles myGridView.RowDataBound

        If e.Row.RowType = DataControlRowType.DataRow Then

            '*** QuestionID ***'
            Dim lblQuestionID As Label = DirectCast(e.Row.FindControl("lblQuestionID"), Label)
            If Not IsNothing(lblQuestionID) Then
                lblQuestionID.Text = e.Row.DataItem("QuestionID")
            End If

            '*** CreateDate ***'
            Dim lblCreateDate As Label = DirectCast(e.Row.FindControl("lblCreateDate"), Label)
            If Not IsNothing(lblCreateDate) Then
                lblCreateDate.Text = CDate(e.Row.DataItem("CreateDate")).ToString("dd/MM/yyyy HH:mm")
            End If

            '*** Question ***'
            Dim hplQuestion As HyperLink = DirectCast(e.Row.FindControl("hplQuestion"), HyperLink)
            If Not IsNothing(hplQuestion) Then
                hplQuestion.Text = e.Row.DataItem("Question")
                hplQuestion.NavigateUrl = "ViewWebboard.aspx?QuestionID=" & e.Row.DataItem("QuestionID")
            End If

            '*** Name ***'
            Dim lblName As Label = DirectCast(e.Row.FindControl("lblName"), Label)
            If Not IsNothing(lblName) Then
                lblName.Text = e.Row.DataItem("Name")
            End If

            '*** View ***'
            Dim lblView As Label = DirectCast(e.Row.FindControl("lblView"), Label)
            If Not IsNothing(lblView) Then
                lblView.Text = e.Row.DataItem("View")
            End If

            '*** Reply ***'
            Dim lblReply As Label = DirectCast(e.Row.FindControl("lblReply"), Label)
            If Not IsNothing(lblReply) Then
                lblReply.Text = e.Row.DataItem("Reply")
            End If

        End If

    End Sub

    Protected Sub Page_Unload(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Unload

        objConn.Close()
        objConn = Nothing

    End Sub

End Class